<template>
    <div class="profileContainer">
        <div class="user">
            <div class="userWrapper">
                <img src="https://i.pinimg.com/236x/91/90/f1/9190f14578899053854171896c3898cd.jpg">
                <h2>{{ userData.name }}</h2>
                <p>Lorem ipsum dolor sit amet consectetur, adipisicing elit. Impedit, pariatur!</p>
                <div class="infobox">
                    <p><b>Urodziny:</b> 12.03</p>
                    <p><b>Miejscowosc:</b> Wejherowo</p>
                    <p v-if="userData.created_at"><b>Data rejestracji:</b> {{ parseDate(userData.created_at) }}</p>
                </div>
                <hr/>
                <div class="socialLinks">
                    <IconDiscord/>
                    <IconTwitter/>
                    <IconFacebook/>
                    <IconMal/>
                    <IconSpotify/>
                </div>
            </div>
        </div>
        <div class="content">
            <div class="timeSummary">
                <h2 class="font-bold">Dni spędzone na konwentach:</h2>
                <div class="chartContainer">
                    <div class="chartSummaryContainer">
                        <!-- <h4>Ranga: Stary Wyjadacz</h4> -->
                        <h4>Łączna ilość dni: {{ totalDays }}</h4>
                        <p>...to o {{ (44000000 - totalDays) }} dni mniej niż ludzi zginęło podczas wielkiego skoku naprzód!</p>
                    </div>
                    <div class="chartWrapper">
                        <Doughnut
                        id="my-chart-id"
                        :options="chartOptions"
                        :data="chartData"
                        />
                    </div>
                </div>
            </div>
            <h2 class="text-lg font-bold">Lista Konwentów</h2>
            <hr/>
            <div class="conListContainer">
                <table class="table table-zebra">
                    <thead>
                    <tr>
                        <th @click="sort('id')">#</th>
                        <th>Obraz</th>
                        <th @click="sort('name')">Nazwa</th>
                        <th @click="sort('date')">Data</th>
                        <th @click="sort('role')">Rola</th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr v-for="con in userData.attended_conventions" :key="con">
                        <td>{{con.id}}</td>
                        <td><img style="width:100px;border-radius: 10%;border: 2px solid #F79824;" src="https://cdn.donmai.us/720x720/38/5d/385d6241d85550ed9eb6d7399d3f7208.webp"></td>
                        <td>{{con.name}}</td>
                        <td>{{ parseDate(con.start_date) }} - {{ parseDate(con.end_date) }}</td>
                        <td>uczestnik</td>
                        <!-- <td>{{ con.role }}</td> -->
                    </tr>
                    </tbody>
                </table>
                <!-- <p>
                <button @click="prevPage" :disabled="cantGoBack">Previous</button> 
                <button @click="nextPage">Next</button>
                </p> -->
            </div>
        </div>
    </div>
</template>

<script>
import apiCalls from '@/services/apiCalls.service'
import utils from '@/services/utils.service';
import { Doughnut } from 'vue-chartjs'
import { Chart as ChartJS, ArcElement, Tooltip, Legend } from 'chart.js'
import IconDiscord from '@/components/icons/IconDiscord.vue';
import IconTwitter from '@/components/icons/IconTwitter.vue';
import IconMal from '@/components/icons/IconMal.vue';
import IconFacebook from '@/components/icons/IconFacebook.vue';
import IconSpotify from '@/components/icons/IconSpotify.vue';

ChartJS.register(ArcElement, Tooltip, Legend)

export default {
    data() {
        return {
            userID: 1,
            userData: {},
            chartData: {
                labels: [ 'Uczestnik', 'Debil', 'Gość', 'Helper' ],
                datasets: [
                    {
                        data: [40, 20, 12, 69],
                        backgroundColor: ['rgb(123, 232, 113)','rgb(123, 232, 3)', 'rgb(123, 32, 213)', 'rgb(223, 32, 113)']
                    }
                ],
            },
            chartOptions: {
                responsive: true,
                circumference: 360,
                plugins: {
                    legend: {
                        position: 'left'
                    }
                }
            },
            totalDays: 0,
        }
    },
    mounted(){
        this.fetchProfile()
    },
    methods: {
        fetchProfile() {
            apiCalls.get(`api/v1/profiles/${this.userID}`)
                .then(res => {
                    this.userData = res
                    this.calculateTotalDays()
                })
        },
        calculateTotalDays() {
            let startDate
            let endDate
            let diff
            this.userData.attended_conventions.forEach(con => {
                startDate = new Date(con.start_date)
                endDate = new Date(con.end_date)
                diff = endDate - startDate
                this.totalDays += Math.floor(diff / (1000*60*60*24))
            })
        },
        calculateRoleDays() { //not tested, waiting for https://gitlab.com/konwenty.moe/backend/-/issues/4
            let groupBy = (xs, key) => {
              return xs.reduce((rv, x) => {
                (rv[x[key]] = rv[x[key]] || []).push(x);
                return rv;
              }, {});
            }
            let groupedCons = groupBy(this.userData.attended_conventions, 'role')

            groupedCons.forEach(role => {
                this.chartData.labels.push(role.name)
                this.chartData.datasets[0].data.push(role.days)
            })
        },
        parseDate : utils.parseDate
    },
    components: {
        Doughnut,
        IconDiscord,
        IconTwitter,
        IconMal,
        IconFacebook,
        IconSpotify
    }
}
</script>

<style scoped>
.profileContainer {
    display: grid;
    grid-template-areas:
        'user content';
    grid-template-columns: 20% 80%;
    margin: 0 10%;

}
.user {
    grid-area: user;
}
.userWrapper {
    display: flex;
    flex-direction: column;
    margin: 2rem;
    padding: 1rem;
    box-shadow: 0 0 20px rgb(87, 82, 82);
    border-radius: 5px;
    width: auto;
}
.userWrapper img {
    height: 33%;
    width: auto;
    object-fit: cover;
}
.userWrapper p, h2 {
    margin: .3rem 0;
}
.content {
    grid-area: content;
}
.content h2,hr {
    text-align: left;
    margin: 1rem 2rem;
}
.infobox p {
    text-align: left;
    margin: .1rem 0;
}

.timeSummary {
    box-shadow: 0 0 20px rgb(87, 82, 82);
    border-radius: 5px;
    text-align: left;
    margin: 2rem;
    padding: 1rem;
}
.timeSummary h2 {
    margin: 0;
}
.chartContainer {
    position: relative;
    display: flex;
    justify-content: space-between;
    flex-direction: row;
    width: 100%;
    max-height: 30vh;
}
.chartWrapper {
    width: 50%;
}
.chartSummaryContainer {
    display: flex;
    flex-direction: column;
    justify-content: center;
    text-align: center;

}
.conListContainer {
    box-shadow: 0 0 20px rgb(87, 82, 82);
    margin: 2rem;
}
th {
    background-color: rgb(200, 200, 200);
    padding: 1rem;
}
td {
    padding: .5rem;
}
.socialLinks{
    display: flex;
    flex-direction: row;
    justify-content: space-around;
}
</style>